/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_PSImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern10 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern10 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern10 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern10 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24)
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 26
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 30
      || GET_MODE (x15) != E_HImode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 0
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 24
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 23
      || GET_MODE (x21) != E_QImode)
    return -1;
  x22 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != MEM
      || GET_MODE (x23) != E_QImode)
    return -1;
  x24 = XVECEXP (x9, 0, 0);
  operands[0] = x24;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x25 = XEXP (x23, 0);
  operands[1] = x25;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern52 (x3, 
E_QImode); /* [-1, 0] */

    case E_QQmode:
      if (pattern52 (x3, 
E_QQmode) != 0)
        return -1;
      return 1;

    case E_UQQmode:
      if (pattern52 (x3, 
E_UQQmode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern52 (x3, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_SQmode:
      if (pattern52 (x3, 
E_SQmode) != 0)
        return -1;
      return 10;

    case E_USQmode:
      if (pattern52 (x3, 
E_USQmode) != 0)
        return -1;
      return 11;

    case E_SAmode:
      if (pattern52 (x3, 
E_SAmode) != 0)
        return -1;
      return 12;

    case E_USAmode:
      if (pattern52 (x3, 
E_USAmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern70 (x1); /* [-1, 6] */

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 26
          || GET_MODE (x6) != E_QImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 7;

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 8; /* [8, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !nonmemory_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_PSImode
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const0_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_low_io_operand (operands[1], E_HImode)
          || !const0_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!reg_or_low_io_operand (operands[1], E_PSImode)
          || !const0_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!reg_or_low_io_operand (operands[1], E_SImode)
          || !const0_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  return 0;
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  return pattern109 (x3); /* [-1, 2] */
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern43 (x1) != 0)
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern84 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern84 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern84 (x1, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pattern84 (x1, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 22
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  switch (REGNO (x5))
    {
    case 18:
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 26
              || GET_MODE (x7) != E_HImode)
            return -1;
          return 0;

        case SIGN_EXTEND:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 26
              || GET_MODE (x7) != E_HImode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 18)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern140 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern140 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern140 (x1, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pattern140 (x1, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 25)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 24)
    return -1;
  return pattern145 (x1); /* [-1, 1] */
}

int
pattern162 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return 0;
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  return pattern176 (x4); /* [-1, 0] */
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_PSImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_MODE (x4))
    {
    case E_QImode:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      operands[2] = x4;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_HImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern82 (x4); /* [-1, 1] */
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern108 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern108 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern108 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern108 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern108 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != NOT
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 18
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[0] = x11;
  if (!pseudo_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x12 = XEXP (x6, 0);
  operands[1] = x12;
  if (!pseudo_register_operand (operands[1], E_HImode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[2] = x13;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_PSImode
      || !register_operand (operands[1], E_PSImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1)
      || !pseudo_register_or_const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return pattern266 (x1); /* [-1, 1] */
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      return pattern269 (
E_QImode); /* [-1, 1] */

    case E_HImode:
      res = pattern269 (
E_HImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern277 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != E_HImode)
    return -1;
  return pattern276 (x1, 
i1, 
i2); /* [-1, 3] */
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode
      || pattern205 (x1, 
E_SImode, 
E_HImode, 
22, 
26) != 0)
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x7) != E_SImode)
            return -1;
          return pattern268 (); /* [-1, 1] */

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x6) != E_PSImode
              || GET_MODE (x7) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern303 (x6);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    case ZERO_EXTEND:
      res = pattern303 (x6);
      if (res >= 0)
        return res + 7; /* [7, 10] */
      return -1;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_8_16_24_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 10)
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_PSImode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 22
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 22
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 18
      || GET_MODE (x12) != E_PSImode)
    return -1;
  x13 = XEXP (x9, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 18
      || GET_MODE (x13) != E_PSImode)
    return -1;
  x14 = XVECEXP (x1, 0, 2);
  x15 = XEXP (x14, 0);
  if (REGNO (x15) != 21
      || GET_MODE (x15) != E_QImode)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (REGNO (x17) != 25
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 5);
  x19 = XEXP (x18, 0);
  if (REGNO (x19) != 36
      || GET_MODE (x19) != E_CCmode
      || GET_MODE (x5) != E_PSImode
      || GET_MODE (x10) != E_PSImode)
    return -1;
  return 0;
}

int
pattern364 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !nonmemory_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern369 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern375 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 30
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern363 (x4); /* [-1, 14] */
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern349 (x3); /* [-1, 0] */
}

int
pattern383 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  return pattern382 (x6); /* [-1, 2] */
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern393 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern387 (x4); /* [-1, 0] */

    case LT:
      if (pattern387 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) == MEM)
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL)
    {
      switch (pattern122 (x3))
        {
        case 0:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 68; /* fxloadqi_A */
            }
          break;

        case 1:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 69; /* fxloadqq_A */
            }
          break;

        case 2:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 70; /* fxloaduqq_A */
            }
          break;

        case 3:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 71; /* fxloadhi_A */
            }
          break;

        case 4:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 72; /* fxloadhq_A */
            }
          break;

        case 5:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 73; /* fxloaduhq_A */
            }
          break;

        case 6:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 74; /* fxloadha_A */
            }
          break;

        case 7:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 75; /* fxloaduha_A */
            }
          break;

        case 8:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 76; /* fxloadsi_A */
            }
          break;

        case 9:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 77; /* fxloadsq_A */
            }
          break;

        case 10:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 78; /* fxloadusq_A */
            }
          break;

        case 11:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 79; /* fxloadsa_A */
            }
          break;

        case 12:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 80; /* fxloadusa_A */
            }
          break;

        case 13:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 81; /* fxloadsf_A */
            }
          break;

        case 14:
          if (
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
            {
              *pnum_clobbers = 3;
              return 82; /* fxloadpsi_A */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 21
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode
      || GET_CODE (x2) != REG
      || REGNO (x2) != 22)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 83; /* fxload_qi_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 98; /* *fxload_qi_libgcc */

    case E_QQmode:
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 84; /* fxload_qq_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 99; /* *fxload_qq_libgcc */

    case E_UQQmode:
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 85; /* fxload_uqq_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 100; /* *fxload_uqq_libgcc */

    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 86; /* fxload_hi_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 101; /* *fxload_hi_libgcc */

    case E_HQmode:
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 87; /* fxload_hq_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 102; /* *fxload_hq_libgcc */

    case E_UHQmode:
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 88; /* fxload_uhq_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 103; /* *fxload_uhq_libgcc */

    case E_HAmode:
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 89; /* fxload_ha_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 104; /* *fxload_ha_libgcc */

    case E_UHAmode:
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 90; /* fxload_uha_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 105; /* *fxload_uha_libgcc */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 91; /* fxload_si_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 106; /* *fxload_si_libgcc */

    case E_SQmode:
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 92; /* fxload_sq_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 107; /* *fxload_sq_libgcc */

    case E_USQmode:
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 93; /* fxload_usq_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 108; /* *fxload_usq_libgcc */

    case E_SAmode:
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 94; /* fxload_sa_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 109; /* *fxload_sa_libgcc */

    case E_USAmode:
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 95; /* fxload_usa_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 110; /* *fxload_usa_libgcc */

    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 96; /* fxload_sf_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 111; /* *fxload_sf_libgcc */

    case E_PSImode:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      if (
#line 715 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
        {
          *pnum_clobbers = 2;
          return 97; /* fxload_psi_libgcc */
        }
      if (!
#line 731 "../../gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      *pnum_clobbers = 1;
      return 112; /* *fxload_psi_libgcc */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          if (XWINT (x4, 0) == 1L)
            return 526; /* *ashiftqihi2.signx.1_split */
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x4;
          if (const_2_to_6_operand (operands[2], E_HImode)
              && 
#line 3092 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 528; /* *ashifthi3.signx.const */
            }
          if (XWINT (x4, 0) != 7L
              || !
#line 3110 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 529; /* *ashifthi3.signx.const7 */

        case 1:
          if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1445; /* *map.shl.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1447; /* *map.shl.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1451; /* *map.shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1449; /* *map.shl.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1453; /* *map.shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1455; /* *map.shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL
              || pattern125 (x2, 
E_HImode) != 0
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 3128 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 530; /* *ashifthi3.zerox.const */

        case AND:
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (pattern37 (x2))
            {
            case 0:
              if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
                return -1;
              return 1446; /* *map.shl.ext.and1-to-skip.hi */

            case 1:
              if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
                return -1;
              return 1448; /* *map.shl.ext.and1-to-skip.psi */

            case 2:
              if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
                return -1;
              return 1452; /* *map.shl.ext.and1-to-skip.psi */

            case 3:
              if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
                return -1;
              return 1450; /* *map.shl.ext.and1-to-skip.si */

            case 4:
              if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
                return -1;
              return 1454; /* *map.shl.ext.and1-to-skip.si */

            case 5:
              if (!
#line 10887 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
                return -1;
              return 1456; /* *map.shl.ext.and1-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_16 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern56 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3304; /* ashldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3308; /* ashldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3312; /* ashludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3316; /* ashlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3320; /* ashluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3324; /* ashlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3328; /* ashluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern74 (x1) != 0)
        return -1;
      return 1013; /* mask1_0x01_split */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern14 (x1))
    {
    case 0:
      return 191; /* *udiff_widenqihi3_split */

    case 1:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      res = recog_8 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern73 (x1))
        {
        case 0:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3196; /* subdi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3203; /* *subdi3_insn */

        case 1:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3197; /* subdq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3204; /* *subdq3_insn */

        case 2:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3198; /* subudq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3205; /* *subudq3_insn */

        case 3:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3199; /* subda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3206; /* *subda3_insn */

        case 4:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3200; /* subuda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3207; /* *subuda3_insn */

        case 5:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3201; /* subta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3208; /* *subta3_insn */

        case 6:
          if (
#line 211 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3202; /* subuta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3209; /* *subuta3_insn */

        case 7:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3210; /* subdi3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3217; /* *subdi3_const_insn */

        case 8:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3211; /* subdq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3218; /* *subdq3_const_insn */

        case 9:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3212; /* subudq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3219; /* *subudq3_const_insn */

        case 10:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3213; /* subda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3220; /* *subda3_const_insn */

        case 11:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3214; /* subuda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3221; /* *subuda3_const_insn */

        case 12:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3215; /* subta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3222; /* *subta3_const_insn */

        case 13:
          if (
#line 236 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3216; /* subuta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3223; /* *subuta3_const_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (pattern137 (x1) == 0)
            return 1081; /* *insv.extract */
          break;

        case REG:
        case SUBREG:
          operands[0] = x5;
          operands[1] = x4;
          switch (pattern181 (x2))
            {
            case 0:
              return 1145; /* *extzvqi_split */

            case 1:
              return 1146; /* *extzvhi_split */

            case 2:
              return 1147; /* *extzvpsi_split */

            case 3:
              return 1148; /* *extzvsi_split */

            case 4:
              return 1153; /* *extzv.qihi1 */

            case 5:
              return 1154; /* *extzv.qihi1 */

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return -1;
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1160; /* *extzv.hi.subreg0 */

        case 1:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1164; /* *extzv.psi.subreg0 */

        case 2:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])))
            return -1;
          return 1168; /* *extzv.si.subreg0 */

        case 3:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1161; /* *extzv.hi.subreg1 */

        case 4:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1165; /* *extzv.psi.subreg1 */

        case 5:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])))
            return -1;
          return 1169; /* *extzv.si.subreg1 */

        case 6:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1162; /* *extzv.hi.subreg2 */

        case 7:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1166; /* *extzv.psi.subreg2 */

        case 8:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])))
            return -1;
          return 1170; /* *extzv.si.subreg2 */

        case 9:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1163; /* *extzv.hi.subreg3 */

        case 10:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1167; /* *extzv.psi.subreg3 */

        case 11:
          if (!
#line 10486 "../../gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])))
            return -1;
          return 1171; /* *extzv.si.subreg3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!
#line 10133 "../../gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))))
            return -1;
          return 1091; /* *insv.xor-extract_split */

        case 1:
          if (!
#line 10509 "../../gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0))
            return -1;
          return 1172; /* *extzv.xor */

        default:
          return -1;
        }

    case NOT:
      if (pattern94 (x1) != 0)
        return -1;
      return 1155; /* *extzv.not_split */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern235 (x1))
        {
        case 0:
          if (
#line 5782 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 708; /* *ashrqi3 */
          break;

        case 1:
          if (
#line 5782 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 709; /* *ashrqq3 */
          break;

        case 2:
          if (
#line 5782 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 710; /* *ashruqq3 */
          break;

        case 3:
          if (
#line 5814 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 716; /* *ashrhi3 */
          break;

        case 4:
          if (
#line 5814 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 717; /* *ashrhq3 */
          break;

        case 5:
          if (
#line 5814 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 718; /* *ashruhq3 */
          break;

        case 6:
          if (
#line 5814 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 719; /* *ashrha3 */
          break;

        case 7:
          if (
#line 5814 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 720; /* *ashruha3 */
          break;

        case 8:
          if (
#line 5874 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 728; /* *ashrsi3 */
          break;

        case 9:
          if (
#line 5874 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 729; /* *ashrsq3 */
          break;

        case 10:
          if (
#line 5874 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 730; /* *ashrusq3 */
          break;

        case 11:
          if (
#line 5874 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 731; /* *ashrsa3 */
          break;

        case 12:
          if (
#line 5874 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 732; /* *ashrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 721; /* ashrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 5910 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 738; /* *ashrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 5910 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 739; /* *ashrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 5910 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 740; /* *ashrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 5910 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 741; /* *ashrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 5910 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 742; /* *ashrusa3_const */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      res = recog_51 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 18)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_DImode:
          if (!const_operand (operands[0], E_DImode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3297; /* compare_const_di2 */

        case E_DQmode:
          if (!const_operand (operands[0], E_DQmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3298; /* compare_const_dq2 */

        case E_UDQmode:
          if (!const_operand (operands[0], E_UDQmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3299; /* compare_const_udq2 */

        case E_DAmode:
          if (!const_operand (operands[0], E_DAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3300; /* compare_const_da2 */

        case E_UDAmode:
          if (!const_operand (operands[0], E_UDAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3301; /* compare_const_uda2 */

        case E_TAmode:
          if (!const_operand (operands[0], E_TAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3302; /* compare_const_ta2 */

        case E_UTAmode:
          if (!const_operand (operands[0], E_UTAmode)
              || !
#line 576 "../../gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3303; /* compare_const_uta2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != SCRATCH
              || GET_MODE (x8) != E_QImode
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x4) != E_CCmode)
            return -1;
          switch (pattern323 (x5))
            {
            case 0:
              if (!
#line 6908 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 875; /* *cmphi_lsr */

            case 1:
              if (!
#line 6908 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 876; /* *cmppsi_lsr */

            case 2:
              if (!
#line 6908 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 877; /* *cmpsi_lsr */

            default:
              return -1;
            }

        case SET:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != LSHIFTRT
              || GET_MODE (x9) != E_QImode
              || GET_MODE (x3) != E_CCZNmode
              || GET_MODE (x4) != E_CCZNmode
              || GET_MODE (x5) != E_QImode
              || pattern332 (x1) != 0
              || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 947; /* *op8.for.cczn.lshiftrt */

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x3))
        {
        case E_CCZNmode:
          if (GET_MODE (x4) != E_CCZNmode)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern339 (x1, pnum_clobbers, 
E_HImode) != 0
                  || !
#line 7334 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 916; /* *add.for.cczn.hi */

            case E_PSImode:
              if (pattern339 (x1, pnum_clobbers, 
E_PSImode) != 0
                  || !
#line 7334 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 917; /* *add.for.cczn.psi */

            case E_SImode:
              if (pattern339 (x1, pnum_clobbers, 
E_SImode) != 0
                  || !
#line 7334 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 918; /* *add.for.cczn.si */

            case E_QImode:
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              if (!nonmemory_operand (operands[4], E_QImode)
                  || !register_operand (operands[0], E_QImode)
                  || GET_MODE (x9) != E_QImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x13 = XEXP (x9, 1);
              operands[2] = x13;
              if (!nonmemory_operand (operands[2], E_QImode)
                  || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 940; /* *op8.for.cczn.plus */

            default:
              return -1;
            }

        case E_CCNmode:
          if (pnum_clobbers == NULL
              || GET_MODE (x4) != E_CCNmode)
            return -1;
          x11 = XEXP (x5, 1);
          operands[1] = x11;
          x12 = XEXP (x9, 0);
          operands[4] = x12;
          x13 = XEXP (x9, 1);
          operands[5] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern364 (x9, 
E_HImode) != 0
                  || !
#line 7353 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 919; /* *add.for.ccn.hi */

            case E_PSImode:
              if (pattern364 (x9, 
E_PSImode) != 0
                  || !
#line 7353 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 920; /* *add.for.ccn.psi */

            case E_SImode:
              if (pattern364 (x9, 
E_SImode) != 0
                  || !
#line 7353 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 921; /* *add.for.ccn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != MINUS
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[4] = x11;
          x13 = XEXP (x9, 1);
          operands[2] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern365 (x9, 
E_HImode) != 0
                  || !
#line 7469 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 922; /* *sub.for.cczn.hi */

            case E_PSImode:
              if (pattern365 (x9, 
E_PSImode) != 0
                  || !
#line 7469 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 923; /* *sub.for.cczn.psi */

            case E_SImode:
              if (pattern365 (x9, 
E_SImode) != 0
                  || !
#line 7469 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 924; /* *sub.for.cczn.si */

            case E_QImode:
              if (pattern365 (x9, 
E_QImode) != 0
                  || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 941; /* *op8.for.cczn.minus */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern351 (x1, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 925; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 927; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 931; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 929; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 933; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 935; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern351 (x1, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 926; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 928; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 932; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 930; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 934; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7485 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 936; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x11 = XEXP (x5, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != ASHIFT)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (XWINT (x11, 0) == 1L)
        {
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[1], E_QImode)
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || GET_MODE (x5) != E_QImode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x11;
      if (!const_1_to_3_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x9) != E_QImode)
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_1_to_3_operand (operands[2], E_QImode)
          || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 945; /* *op8.for.cczn.ashift */

    case AND:
      if (pattern207 (x1, 
AND) != 0
          || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 942; /* *op8.for.cczn.and */

    case IOR:
      if (pattern207 (x1, 
IOR) != 0
          || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 943; /* *op8.for.cczn.ior */

    case XOR:
      if (pattern208 (x1, 
XOR) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x6, 1);
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 944; /* *op8.for.cczn.xor */

    case ASHIFTRT:
      if (pattern208 (x1, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || pattern332 (x1) != 0
          || !
#line 7606 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 946; /* *op8.for.cczn.ashiftrt */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern106 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x4) == REG)
        {
          res = recog_80 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      switch (pattern264 (x1))
        {
        case 0:
          if (!
#line 3403 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 541; /* *mulsi3 */

        case 1:
          if (!
#line 4197 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 601; /* *mulpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG)
        {
          switch (pattern267 (x1))
            {
            case 0:
              if (
#line 2437 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return 476; /* *umulqihi3.call_split */
              break;

            case 1:
              if (
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                return 3361; /* umulsidi3_insn */
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern271 (x1))
        {
        case 0:
          if (!
#line 3483 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 543; /* *muluqisi3 */

        case 1:
          if (!
#line 3483 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 544; /* *muluhisi3 */

        case 2:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 549; /* *usmulqiqisi3 */

        case 3:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 557; /* *usmulqihisi3 */

        case 4:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 553; /* *usmulhiqisi3 */

        case 5:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 561; /* *usmulhihisi3 */

        case 6:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 551; /* *uumulqiqisi3 */

        case 7:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 559; /* *uumulqihisi3 */

        case 8:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 555; /* *uumulhiqisi3 */

        case 9:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          return 563; /* *uumulhihisi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 26
          || GET_MODE (x7) != E_HImode)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) == 18)
        {
          switch (pattern304 (x1))
            {
            case 0:
              if (
#line 3535 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 545; /* *mulsqisi3 */
              break;

            case 1:
              if (
#line 3535 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 546; /* *mulshisi3 */
              break;

            case 2:
              if (
#line 4178 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 600; /* *mulsqipsi3 */
              break;

            case 3:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 548; /* *ssmulqiqisi3 */
              break;

            case 4:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 556; /* *ssmulqihisi3 */
              break;

            case 5:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 552; /* *ssmulhiqisi3 */
              break;

            case 6:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 560; /* *ssmulhihisi3 */
              break;

            case 7:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 550; /* *sumulqiqisi3 */
              break;

            case 8:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 558; /* *sumulqihisi3 */
              break;

            case 9:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 554; /* *sumulhiqisi3 */
              break;

            case 10:
              if (
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return 562; /* *sumulhihisi3 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || pattern305 (x1) != 0
          || !
#line 675 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        return -1;
      return 3360; /* mulsidi3_insn */

    case NOT:
      if (pattern244 (x1) != 0
          || !
#line 3594 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      return 547; /* *mulohisi3 */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_90 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_78 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          if (pattern28 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 7);
              if (pattern386 (x2, 
E_CCmode, 
36) == 0)
                {
                  switch (pattern385 (x1))
                    {
                    case 0:
                      if (
#line 1347 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 162; /* *cpymem_qi */
                      break;

                    case 1:
                      if (
#line 1347 "../../gcc/config/avr/avr.md"
(reload_completed))
                        return 163; /* *cpymem_hi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              return 164; /* cpymemx_qi */

            case 1:
              return 165; /* cpymemx_hi */

            default:
              break;
            }
          break;

        case 10:
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_88 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_89 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 6)
        return -1;
      operands[0] = x1;
      if (!set_some_operation (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern177 (x1, 
USE) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!dreg_or_0_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[5] = x12;
      if (!register_operand (operands[5], E_QImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_QImode)
          || !
#line 1225 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 156; /* set_some */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 972; /* nop */

    case RETURN:
      if (
#line 8681 "../../gcc/config/avr/avr.md"
(reload_completed && avr_simple_epilogue ()))
        return 999; /* return */
      if (
#line 8687 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && !(cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1000; /* return_from_epilogue */
      if (
#line 8696 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && (cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1001; /* return_from_interrupt_epilogue */
      if (!
#line 8705 "../../gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && cfun->machine->is_naked))
        return -1;
      return 1002; /* return_from_naked_epilogue */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XEXP (x3, 1);
  switch (pattern280 (x5))
    {
    case 0:
      if (!(
#line 2465 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2467 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_271 (insn, operands);

    case 1:
      if (!(
#line 2513 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2515 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 2:
      if (!(
#line 3149 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3151 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern194 (x2) != 0
              || !(
#line 2465 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2467 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_PSImode:
          switch (pattern195 (x2))
            {
            case 0:
              if (!(
#line 4108 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4110 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case 1:
              if (!(
#line 4135 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4137 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2488 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2490 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_273 (insn, operands);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 3174 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3176 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern90 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern258 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode)
                  && 
#line 6994 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_569 (insn, operands);
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode)
                  && 
#line 6994 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_570 (insn, operands);
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode)
                  && 
#line 6994 "../../gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_571 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_595 (insn, operands);
          break;

        case 2:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_597 (insn, operands);
          break;

        case 3:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_601 (insn, operands);
          break;

        case 4:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_599 (insn, operands);
          break;

        case 5:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_603 (insn, operands);
          break;

        case 6:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_605 (insn, operands);
          break;

        case 7:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_596 (insn, operands);
          break;

        case 8:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_598 (insn, operands);
          break;

        case 9:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_602 (insn, operands);
          break;

        case 10:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_600 (insn, operands);
          break;

        case 11:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_604 (insn, operands);
          break;

        case 12:
          if ((
#line 7127 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7130 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_606 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 18)
        return NULL;
      x5 = XEXP (x2, 1);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 10)
            return NULL;
          switch (pattern329 (x3))
            {
            case 0:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1920 (insn, operands);

            case 1:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1921 (insn, operands);

            case 2:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1922 (insn, operands);

            case 3:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1923 (insn, operands);

            case 4:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1924 (insn, operands);

            case 5:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1925 (insn, operands);

            case 6:
              if (!(
#line 500 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1926 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern296 (x3) != 0
              || !(
#line 529 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 531 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1927 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern230 (x2))
        {
        case 0:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_583 (insn, operands);

        case 1:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_585 (insn, operands);

        case 2:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_589 (insn, operands);

        case 3:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_587 (insn, operands);

        case 4:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_591 (insn, operands);

        case 5:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_593 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern230 (x2))
        {
        case 0:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 1:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_586 (insn, operands);

        case 2:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_590 (insn, operands);

        case 3:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_588 (insn, operands);

        case 4:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_592 (insn, operands);

        case 5:
          if (!(
#line 7096 "../../gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7099 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_594 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern152 (x3) != 0
          || !
#line 4632 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_371 (insn, operands);

    case LSHIFTRT:
      switch (pattern81 (x3))
        {
        case 0:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 1:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_672 (insn, operands);

        case 2:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_676 (insn, operands);

        case 3:
          if (!
#line 10992 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1019 (insn, operands);

        case 4:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_692 (insn, operands);

        case 5:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 6:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_704 (insn, operands);

        case 7:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_700 (insn, operands);

        case 8:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_708 (insn, operands);

        case 9:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_712 (insn, operands);

        case 10:
          if (!
#line 11043 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1025 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern83 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern79 (x3, 
E_HImode) == 0
                  && (
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_670 (insn, operands);
              break;

            case E_PSImode:
              if (pattern79 (x3, 
E_PSImode) == 0
                  && (
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_674 (insn, operands);
              break;

            case E_SImode:
              if (pattern79 (x3, 
E_SImode) == 0
                  && (
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_678 (insn, operands);
              break;

            case E_QImode:
              if (pattern80 (x3) == 0
                  && 
#line 11112 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
                return gen_split_1030 (insn, operands);
              break;

            default:
              break;
            }
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) != 8L
              || pattern218 (x3) != 0
              || !(
#line 10264 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10266 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_719 (insn, operands);

        case 1:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern46 (x3))
            {
            case 0:
              if ((
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_694 (insn, operands);
              break;

            case 1:
              if ((
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_698 (insn, operands);
              break;

            case 2:
              if ((
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_706 (insn, operands);
              break;

            case 3:
              if ((
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_702 (insn, operands);
              break;

            case 4:
              if ((
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_710 (insn, operands);
              break;

            case 5:
              if ((
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_714 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L)
            return NULL;
          switch (pattern228 (x3))
            {
            case 0:
              if (!(
#line 10215 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10217 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_716 (insn, operands);

            case 1:
              if (!(
#line 10248 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10250 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_718 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_913 (insn, operands);

        case 3:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_919 (insn, operands);

        case 4:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_931 (insn, operands);

        case 5:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_925 (insn, operands);

        case 6:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_937 (insn, operands);

        case 7:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_943 (insn, operands);

        case 8:
          if (!(
#line 10215 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10217 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_715 (insn, operands);

        case 9:
          if (!(
#line 10248 "../../gcc/config/avr/avr.md"
(optimize) && 
#line 10250 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_717 (insn, operands);

        case 10:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_912 (insn, operands);

        case 11:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_918 (insn, operands);

        case 12:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_930 (insn, operands);

        case 13:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_924 (insn, operands);

        case 14:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_936 (insn, operands);

        case 15:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_942 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern3 (x3))
        {
        case 0:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_680 (insn, operands);

        case 1:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_682 (insn, operands);

        case 2:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_686 (insn, operands);

        case 3:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_684 (insn, operands);

        case 4:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_688 (insn, operands);

        case 5:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_690 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x3))
            {
            case 0:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_815 (insn, operands);

            case 1:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_827 (insn, operands);

            case 2:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            case 3:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_851 (insn, operands);

            case 4:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_818 (insn, operands);

            case 5:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_830 (insn, operands);

            case 6:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_842 (insn, operands);

            case 7:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_854 (insn, operands);

            case 8:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_821 (insn, operands);

            case 9:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_833 (insn, operands);

            case 10:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_845 (insn, operands);

            case 11:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_857 (insn, operands);

            case 12:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_824 (insn, operands);

            case 13:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_836 (insn, operands);

            case 14:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_848 (insn, operands);

            case 15:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_860 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_947 (insn, operands);

            case 1:
              if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_950 (insn, operands);

            case 2:
              if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_953 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern87 (x3))
        {
        case 0:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_863 (insn, operands);

        case 1:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_866 (insn, operands);

        case 2:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_869 (insn, operands);

        case 3:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_872 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_876 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_882 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_894 (insn, operands);

        case 7:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_888 (insn, operands);

        case 8:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_900 (insn, operands);

        case 9:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_906 (insn, operands);

        case 10:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_877 (insn, operands);

        case 11:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_883 (insn, operands);

        case 12:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_895 (insn, operands);

        case 13:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_889 (insn, operands);

        case 14:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_901 (insn, operands);

        case 15:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_907 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 10948 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1016 (insn, operands);

        case 1:
          if (!
#line 11018 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1022 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern121 (x3) != 0
          || !
#line 11067 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1028 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      x5 = XEXP (x3, 0);
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern178 (x3))
                {
                case 0:
                  return gen_split_517 (insn, operands);

                case 1:
                  return gen_split_518 (insn, operands);

                case 2:
                  return gen_split_519 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern178 (x3))
                {
                case 0:
                  return gen_split_520 (insn, operands);

                case 1:
                  return gen_split_521 (insn, operands);

                case 2:
                  return gen_split_522 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              if (d_register_operand (operands[0], E_QImode)
                  && GET_MODE (x3) == E_QImode)
                return gen_split_523 (insn, operands);
              break;

            default:
              break;
            }
        }
    }
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  operands[2] = x4;
  switch (pattern153 (x3))
    {
    case 0:
      if (
#line 5976 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_524 (insn, operands);
      break;

    case 1:
      if (
#line 5976 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_525 (insn, operands);
      break;

    case 2:
      if (
#line 5976 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_526 (insn, operands);
      break;

    case 3:
      if (
#line 6002 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_527 (insn, operands);
      break;

    case 4:
      if (
#line 6002 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_528 (insn, operands);
      break;

    case 5:
      if (
#line 6002 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_529 (insn, operands);
      break;

    case 6:
      if (
#line 6002 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_530 (insn, operands);
      break;

    case 7:
      if (
#line 6002 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_531 (insn, operands);
      break;

    case 8:
      if (
#line 6061 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_533 (insn, operands);
      break;

    case 9:
      if (
#line 6061 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_534 (insn, operands);
      break;

    case 10:
      if (
#line 6061 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_535 (insn, operands);
      break;

    case 11:
      if (
#line 6061 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_536 (insn, operands);
      break;

    case 12:
      if (
#line 6061 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_537 (insn, operands);
      break;

    default:
      break;
    }
  if (reg_or_low_io_operand (operands[1], E_QImode)
      && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
      && register_operand (operands[0], E_QImode)
      && GET_MODE (x3) == E_QImode
      && (
#line 10560 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10562 "../../gcc/config/avr/avr.md"
( 1)))
    return gen_split_751 (insn, operands);
  if (GET_CODE (x5) != REG)
    return NULL;
  switch (pattern56 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1949 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1953 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1957 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1961 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern308 (x6, 
E_HImode) != 0
              || !
#line 2135 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_HQmode:
          if (pattern308 (x6, 
E_HQmode) != 0
              || !
#line 2135 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_153 (insn, operands);

        case E_UHQmode:
          if (pattern308 (x6, 
E_UHQmode) != 0
              || !
#line 2135 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_154 (insn, operands);

        case E_HAmode:
          if (pattern308 (x6, 
E_HAmode) != 0
              || !
#line 2135 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_155 (insn, operands);

        case E_UHAmode:
          if (pattern308 (x6, 
E_UHAmode) != 0
              || !
#line 2135 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_156 (insn, operands);

        case E_SImode:
          if (pattern308 (x6, 
E_SImode) != 0
              || !
#line 2165 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_157 (insn, operands);

        case E_SQmode:
          if (pattern308 (x6, 
E_SQmode) != 0
              || !
#line 2165 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_158 (insn, operands);

        case E_USQmode:
          if (pattern308 (x6, 
E_USQmode) != 0
              || !
#line 2165 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_159 (insn, operands);

        case E_SAmode:
          if (pattern308 (x6, 
E_SAmode) != 0
              || !
#line 2165 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_160 (insn, operands);

        case E_USAmode:
          if (pattern308 (x6, 
E_USAmode) != 0
              || !
#line 2165 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_161 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      switch (pattern234 (x6))
        {
        case 0:
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 2662 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2664 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_280 (insn, operands);

        case 1:
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2877 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2879 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_292 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2968 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2971 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 2:
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2877 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2879 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_293 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern222 (x6) != 0)
        return NULL;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (pattern352 (x10))
        {
        case 0:
          if (!(
#line 2900 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2902 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_294 (insn, operands);

        case 1:
          if (!(
#line 2924 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2926 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_295 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 892 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_1 (insn, operands);

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 892 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 892 "../../gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    case E_HImode:
      if (l_register_operand (operands[0], E_HImode)
          && const_or_immediate_operand (operands[1], E_HImode)
          && 
#line 931 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HImode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_4 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2
          || !d_register_operand (operands[0], E_HImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != PARALLEL)
        return NULL;
      if (const_int_operand (operands[1], E_HImode))
        {
          switch (XVECLEN (x6, 0))
            {
            case 3:
              switch (pattern312 (x6, 
E_HImode))
                {
                case 0:
                  if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_15 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_16 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_17 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
              break;

            case 2:
              if (pattern315 (x6, 
E_HImode, 
PLUS) == 0)
                {
                  x7 = XVECEXP (x6, 0, 0);
                  x8 = XEXP (x7, 1);
                  x9 = XEXP (x8, 1);
                  operands[2] = x9;
                  if (register_operand (operands[2], E_HImode))
                    {
                      x10 = XEXP (x8, 0);
                      if (rtx_equal_p (x10, operands[0]))
                        {
                          x11 = XEXP (x7, 0);
                          if (rtx_equal_p (x11, operands[0])
                              && 
#line 1055 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                            {
                              *pmatch_len_ = 1;
                              res = gen_peephole2_24 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                    }
                }
              break;

            default:
              break;
            }
        }
      if (XVECLEN (x6, 0) != 2
          || !const_operand (operands[1], E_HImode)
          || pattern310 (x6, 
E_HImode) != 0
          || !
#line 1868 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_32 (insn, operands);

    case E_HQmode:
      if (l_register_operand (operands[0], E_HQmode)
          && const_or_immediate_operand (operands[1], E_HQmode)
          && 
#line 931 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_5 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_HQmode) != 0
          || !
#line 1868 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_33 (insn, operands);

    case E_UHQmode:
      if (l_register_operand (operands[0], E_UHQmode)
          && const_or_immediate_operand (operands[1], E_UHQmode)
          && 
#line 931 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_6 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_UHQmode) != 0
          || !
#line 1868 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_34 (insn, operands);

    case E_HAmode:
      if (l_register_operand (operands[0], E_HAmode)
          && const_or_immediate_operand (operands[1], E_HAmode)
          && 
#line 931 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_7 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_HAmode) != 0
          || !
#line 1868 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    case E_UHAmode:
      if (l_register_operand (operands[0], E_UHAmode)
          && const_or_immediate_operand (operands[1], E_UHAmode)
          && 
#line 931 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_8 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_UHAmode) != 0
          || !
#line 1868 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_36 (insn, operands);

    case E_PSImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern313 (x6, 
E_PSImode))
            {
            case 0:
              if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_18 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_19 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_20 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1108 "../../gcc/config/avr/avr.md"
(operands[1] != const0_rtx
   && operands[1] != constm1_rtx))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_25 (insn, operands);

    case E_SImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern313 (x6, 
E_SImode))
            {
            case 0:
              if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_21 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_22 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1036 "../../gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_23 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1163 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SImode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_26 (insn, operands);

    case E_SQmode:
      if (!l_register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1163 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_27 (insn, operands);

    case E_USQmode:
      if (!l_register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1163 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_28 (insn, operands);

    case E_SAmode:
      if (!l_register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1163 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_29 (insn, operands);

    case E_USAmode:
      if (!l_register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1163 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_30 (insn, operands);

    case E_SFmode:
      if (!l_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1267 "../../gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SFmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_31 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != PARALLEL)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern326 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QImode)
          && even_register_operand (operands[0], E_QImode)
          && even_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QImode)
              && 
#line 987 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QImode)
          && odd_register_operand (operands[0], E_QImode)
          && odd_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QImode)
              && 
#line 1005 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern376 (x8, 
E_QImode))
        {
        case 0:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_76 (insn, operands);

        case 1:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_77 (insn, operands);

        case 2:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_78 (insn, operands);

        default:
          return NULL;
        }

    case E_QQmode:
      if (pattern326 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QQmode)
          && even_register_operand (operands[0], E_QQmode)
          && even_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QQmode)
              && 
#line 987 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QQmode)
          && odd_register_operand (operands[0], E_QQmode)
          && odd_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QQmode)
              && 
#line 1005 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_13 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern376 (x8, 
E_QQmode))
        {
        case 0:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_79 (insn, operands);

        case 1:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_80 (insn, operands);

        case 2:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_81 (insn, operands);

        default:
          return NULL;
        }

    case E_UQQmode:
      if (pattern326 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_UQQmode)
          && even_register_operand (operands[0], E_UQQmode)
          && even_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_UQQmode)
              && 
#line 987 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_UQQmode)
          && odd_register_operand (operands[0], E_UQQmode)
          && odd_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_UQQmode)
              && 
#line 1005 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_14 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern376 (x8, 
E_UQQmode))
        {
        case 0:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_82 (insn, operands);

        case 1:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_83 (insn, operands);

        case 2:
          if (!
#line 4986 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_84 (insn, operands);

        default:
          return NULL;
        }

    case E_HImode:
      switch (pattern327 (x7, 
E_HImode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_45 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern327 (x7, 
E_SImode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_46 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_47 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_48 (insn, operands);

        default:
          return NULL;
        }

    case E_PSImode:
      switch (pattern327 (x7, 
E_PSImode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_49 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_50 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_51 (insn, operands);

        default:
          return NULL;
        }

    case E_HQmode:
      switch (pattern327 (x7, 
E_HQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_52 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_53 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_54 (insn, operands);

        default:
          return NULL;
        }

    case E_UHQmode:
      switch (pattern327 (x7, 
E_UHQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_55 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_56 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_57 (insn, operands);

        default:
          return NULL;
        }

    case E_HAmode:
      switch (pattern327 (x7, 
E_HAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_58 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_59 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_60 (insn, operands);

        default:
          return NULL;
        }

    case E_UHAmode:
      switch (pattern327 (x7, 
E_UHAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_61 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        default:
          return NULL;
        }

    case E_SQmode:
      switch (pattern327 (x7, 
E_SQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_64 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_65 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_66 (insn, operands);

        default:
          return NULL;
        }

    case E_USQmode:
      switch (pattern327 (x7, 
E_USQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_67 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_68 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_69 (insn, operands);

        default:
          return NULL;
        }

    case E_SAmode:
      switch (pattern327 (x7, 
E_SAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_70 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_71 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_72 (insn, operands);

        default:
          return NULL;
        }

    case E_USAmode:
      switch (pattern327 (x7, 
E_USAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_73 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_74 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
