/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i1)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SAmode)
        return -1;
      return 0;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_USAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_USAmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  return pattern37 (x1); /* [-1, 5] */
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern41 (x2); /* [-1, 1] */
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      if (REGNO (x2) != 24)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x2) != 22)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_CODE (operands[3]))
        {
        case CONST_INT:
          return pattern76 (x1); /* [-1, 3] */

        case REG:
        case SUBREG:
          if (!register_operand (operands[3], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || GET_MODE (x2) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case XOR:
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!const_int_operand (operands[4], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTEND:
      return 2;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 2);
  operands[3] = x4;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[4] = x10;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!reg_or_low_io_operand (operands[1], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!single_one_operand (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern108 (x1, 
E_HImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern108 (x1, 
E_PSImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern108 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG)
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG)
    return -1;
  x16 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 24:
      return 0;

    case 22:
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[2], E_QImode)
              || !const7_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[2], E_HImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[2], E_PSImode)
              || !const23_operand (operands[3], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode)
              || !const31_operand (operands[3], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x5) != E_PSImode
              || !const23_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !const31_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 21
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 30
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode)
          || GET_MODE (x5) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode)
          || GET_MODE (x5) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode)
          || GET_MODE (x5) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode)
          || GET_MODE (x5) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode)
          || GET_MODE (x5) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode)
          || GET_MODE (x5) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode)
          || GET_MODE (x5) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode)
          || GET_MODE (x5) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode)
          || GET_MODE (x5) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode)
          || GET_MODE (x5) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode)
          || GET_MODE (x5) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode)
          || GET_MODE (x5) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode)
          || GET_MODE (x5) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_2_to_7_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 6
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern247 (x1) != 0)
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern185 (x5); /* [-1, 10] */
}

int
pattern256 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || pattern260 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern268 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 30
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern272 (x4); /* [-1, 1] */
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 3
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 32
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 32
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC_VOLATILE
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_BLKmode
      || !const_int_operand (operands[0], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  operands[1] = x9;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  x11 = XVECEXP (x7, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (REGNO (x5) != 25
      || pattern260 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 4:
      return pattern291 (x1); /* [-1, 0] */

    case 5:
      if (pattern291 (x1) != 0)
        return -1;
      return 1;

    case 6:
      if (pattern291 (x1) != 0)
        return -1;
      return 2;

    case 8:
      x4 = XVECEXP (x3, 0, 1);
      if (REGNO (x4) != 24)
        return -1;
      res = pattern292 (x1);
      if (res >= 0)
        return res + 3; /* [3, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern302 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern308 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern312 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x7))
    {
    case PLUS:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 21
          || GET_MODE (x7) != E_QImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      return 0;

    case 25:
      if (pattern337 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern347 (x3); /* [-1, 1] */
}

int
pattern352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_2_to_7_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_1_to_6_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern357 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 18
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 6);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern394 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern387 (x1); /* [-1, 0] */

    case NE:
      if (pattern387 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern387 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern387 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern387 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern387 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (pattern124 (x1, 
E_QImode) != 0)
        return -1;
      return 174; /* addqi3 */

    case E_QQmode:
      if (pattern124 (x1, 
E_QQmode) != 0)
        return -1;
      return 175; /* addqq3 */

    case E_UQQmode:
      if (pattern124 (x1, 
E_UQQmode) != 0)
        return -1;
      return 176; /* adduqq3 */

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      operands[1] = x2;
      if (stack_register_operand (operands[1], E_HImode))
        {
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (stack_register_operand (operands[2], E_HImode))
            {
              x5 = XEXP (x3, 1);
              operands[0] = x5;
              if (avr_sp_immediate_operand (operands[0], E_HImode))
                return 193; /* *addhi3_sp */
            }
        }
      operands[0] = x2;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HImode))
        return 194; /* *addhi3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 204; /* addhi3_clobber */

    case E_HQmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HQmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HQmode))
        return 195; /* *addhq3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HQmode))
        return -1;
      *pnum_clobbers = 1;
      return 205; /* addhq3_clobber */

    case E_UHQmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_UHQmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_UHQmode))
        return 196; /* *adduhq3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_UHQmode))
        return -1;
      *pnum_clobbers = 1;
      return 206; /* adduhq3_clobber */

    case E_HAmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HAmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HAmode))
        return 197; /* *addha3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HAmode))
        return -1;
      *pnum_clobbers = 1;
      return 207; /* addha3_clobber */

    case E_UHAmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_UHAmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_UHAmode))
        return 198; /* *adduha3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_UHAmode))
        return -1;
      *pnum_clobbers = 1;
      return 208; /* adduha3_clobber */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 214; /* addsi3 */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_SQmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 215; /* addsq3 */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_USQmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 216; /* addusq3 */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_SAmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 217; /* addsa3 */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_USAmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 218; /* addusa3 */

    case E_PSImode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_PSImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 270; /* addpsi3 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (pattern255 (x5, pnum_clobbers))
    {
    case 0:
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 522; /* *muluqihi3.uconst */
        }
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3012 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 523; /* *muluqihi3.sconst */

    case 1:
      if (
#line 3174 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 533; /* muluqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3187 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern197 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 2465 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 478; /* mulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 480; /* mulqihi3 */

        case 1:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 548; /* *ssmulqiqisi3 */

        case 2:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 556; /* *ssmulqihisi3 */

        case 3:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 552; /* *ssmulhiqisi3 */

        case 4:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 560; /* *ssmulhihisi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern197 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 2513 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 484; /* *sumulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2526 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 485; /* *sumulqihi3 */

        case 1:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 550; /* *sumulqiqisi3 */

        case 2:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 558; /* *sumulqihisi3 */

        case 3:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 554; /* *sumulhiqisi3 */

        case 4:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 562; /* *sumulhihisi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      if (register_operand (operands[0], E_HImode))
        {
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_MODE (x5) != E_SImode
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!pseudo_register_operand (operands[1], E_QImode)
                  || !
#line 3535 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 545; /* *mulsqisi3 */

            case E_HImode:
              if (!pseudo_register_operand (operands[1], E_HImode)
                  || !
#line 3535 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 546; /* *mulshisi3 */

            default:
              return -1;
            }

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_MODE (x5) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
              || !
#line 4178 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 600; /* *mulsqipsi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 22:
      if (pnum_clobbers == NULL
          || pattern165 (x1, 
E_SImode, 
22) != 0
          || !
#line 6311 "../../gcc/config/avr/avr.md"
(reload_completed
   && optimize_size))
        return -1;
      *pnum_clobbers = 1;
      return 794; /* *negsi2.libgcc */

    case 18:
      if (pattern165 (x1, 
E_DImode, 
18) != 0)
        return -1;
      if (
#line 421 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3272; /* negdi2_insn */
      if (pnum_clobbers == NULL
          || !
#line 432 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3273; /* *negdi2_insn */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern75 (x1, pnum_clobbers))
        {
        case 0:
          return 626; /* iorqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 628; /* iorhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 630; /* iorpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 632; /* iorsi3 */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_one_operand (operands[1], E_QImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 981; /* *sbi */

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          operands[2] = x6;
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XWINT (x6, 0) != 127L)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_QImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || pattern217 (x2, 
E_QImode) != 0)
            return -1;
          return 1075; /* *movbitqi.7 */

        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1273; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1285; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1297; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1309; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1276; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1288; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1300; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1312; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1279; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1291; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1303; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1315; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1282; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1294; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1306; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1318; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1405; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1408; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1411; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern81 (x2))
        {
        case 0:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1093; /* *iorhi.lshiftrt */

        case 1:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1097; /* *iorpsi.lshiftrt */

        case 2:
          if (!
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1101; /* *iorsi.lshiftrt */

        case 3:
          if (!
#line 10988 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (IOR, operands)))
            return -1;
          return 1480; /* *nzb=1.ior.lsr_split */

        case 4:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1117; /* *iorhiqi.lshiftrt */

        case 5:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1121; /* *iorpsiqi.lshiftrt */

        case 6:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1129; /* *iorpsihi.lshiftrt */

        case 7:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1125; /* *iorsiqi.lshiftrt */

        case 8:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1133; /* *iorsihi.lshiftrt */

        case 9:
          if (!
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1137; /* *iorsipsi.lshiftrt */

        case 10:
          if (!
#line 11038 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (IOR, operands)))
            return -1;
          return 1486; /* *nzb=1.ior.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern83 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern79 (x2, 
E_HImode) == 0
                  && 
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
                return 1095; /* *iorhi.ashift */
              break;

            case E_PSImode:
              if (pattern79 (x2, 
E_PSImode) == 0
                  && 
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
                return 1099; /* *iorpsi.ashift */
              break;

            case E_SImode:
              if (pattern79 (x2, 
E_SImode) == 0
                  && 
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
                return 1103; /* *iorsi.ashift */
              break;

            case E_QImode:
              if (pattern80 (x2) == 0
                  && 
#line 11108 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && nonzero_bits (operands[1], QImode) == 1))
                return 1494; /* *nzb=1.ior.ashift_split */
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 1);
          if (XWINT (x6, 0) != 8L
              || pattern218 (x2) != 0
              || !
#line 10264 "../../gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1144; /* *iorhi3.ashift8-reg.zerox */

        case 1:
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (pattern46 (x2))
            {
            case 0:
              if (
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
                return 1119; /* *iorhiqi.ashift */
              break;

            case 1:
              if (
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
                return 1123; /* *iorpsiqi.ashift */
              break;

            case 2:
              if (
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
                return 1131; /* *iorpsihi.ashift */
              break;

            case 3:
              if (
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
                return 1127; /* *iorsiqi.ashift */
              break;

            case 4:
              if (
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
                return 1135; /* *iorsihi.ashift */
              break;

            case 5:
              if (
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
                return 1139; /* *iorsipsi.ashift */
              break;

            default:
              break;
            }
          if (XWINT (x6, 0) != 8L)
            return -1;
          switch (pattern228 (x2))
            {
            case 0:
              if (!
#line 10215 "../../gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1141; /* *iorhi3.ashift8-ext.zerox */

            case 1:
              if (!
#line 10248 "../../gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1143; /* *iorhi3.ashift8-ext.reg */

            default:
              return -1;
            }

        case 2:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1371; /* *shl.ext.and1-to-skip.hi */

        case 3:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1377; /* *shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1389; /* *shl.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1383; /* *shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1395; /* *shl.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1401; /* *shl.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10215 "../../gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1140; /* *iorhi3.ashift8-ext.zerox */

        case 9:
          if (!
#line 10248 "../../gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1142; /* *iorhi3.ashift8-ext.reg */

        case 10:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1370; /* *shl.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1376; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1388; /* *shl.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1382; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1394; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1400; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 1105; /* *iorhiqi.0 */

        case 1:
          return 1107; /* *iorpsiqi.0 */

        case 2:
          return 1111; /* *iorpsihi.0 */

        case 3:
          return 1109; /* *iorsiqi.0 */

        case 4:
          return 1113; /* *iorsihi.0 */

        case 5:
          return 1115; /* *iorsipsi.0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1321; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1324; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1327; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1330; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1334; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1340; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1352; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1346; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1358; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1364; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1335; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1341; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1353; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1347; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1359; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1365; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (IOR == IOR || IOR == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1474; /* *nzb=1.ior.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (IOR == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1483; /* *nzb=1.ior.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (IOR == IOR || IOR == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1489; /* *nzb=1.ior.ge0_split */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern108 (x4, 
E_QImode) == 0
                  && 
#line 1590 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 177; /* *addqi3 */
              break;

            case E_QQmode:
              if (pattern108 (x4, 
E_QQmode) == 0
                  && 
#line 1590 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 178; /* *addqq3 */
              break;

            case E_UQQmode:
              if (pattern108 (x4, 
E_UQQmode) == 0
                  && 
#line 1590 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 179; /* *adduqq3 */
              break;

            case E_HImode:
              if (pattern308 (x4, 
E_HImode) == 0
                  && 
#line 1848 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 199; /* *addhi3 */
              break;

            case E_HQmode:
              if (pattern308 (x4, 
E_HQmode) == 0
                  && 
#line 1848 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 200; /* *addhq3 */
              break;

            case E_UHQmode:
              if (pattern308 (x4, 
E_UHQmode) == 0
                  && 
#line 1848 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 201; /* *adduhq3 */
              break;

            case E_HAmode:
              if (pattern308 (x4, 
E_HAmode) == 0
                  && 
#line 1848 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 202; /* *addha3 */
              break;

            case E_UHAmode:
              if (pattern308 (x4, 
E_UHAmode) == 0
                  && 
#line 1848 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 203; /* *adduha3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern307 (x4, 
E_HImode) != 0)
            return -1;
          return 204; /* addhi3_clobber */

        case E_HQmode:
          if (pattern307 (x4, 
E_HQmode) != 0)
            return -1;
          return 205; /* addhq3_clobber */

        case E_UHQmode:
          if (pattern307 (x4, 
E_UHQmode) != 0)
            return -1;
          return 206; /* adduhq3_clobber */

        case E_HAmode:
          if (pattern307 (x4, 
E_HAmode) != 0)
            return -1;
          return 207; /* addha3_clobber */

        case E_UHAmode:
          if (pattern307 (x4, 
E_UHAmode) != 0)
            return -1;
          return 208; /* adduha3_clobber */

        case E_SImode:
          if (pattern108 (x4, 
E_SImode) != 0)
            return -1;
          return 214; /* addsi3 */

        case E_SQmode:
          if (pattern108 (x4, 
E_SQmode) != 0)
            return -1;
          return 215; /* addsq3 */

        case E_USQmode:
          if (pattern108 (x4, 
E_USQmode) != 0)
            return -1;
          return 216; /* addusq3 */

        case E_SAmode:
          if (pattern108 (x4, 
E_SAmode) != 0)
            return -1;
          return 217; /* addsa3 */

        case E_USAmode:
          if (pattern108 (x4, 
E_USAmode) != 0)
            return -1;
          return 218; /* addusa3 */

        case E_PSImode:
          if (pattern108 (x4, 
E_PSImode) != 0)
            return -1;
          return 270; /* addpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern262 (x1, 
E_HImode) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1672 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 183; /* *addhi3_zero_extend1 */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern235 (x1))
        {
        case 0:
          if (
#line 5987 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 746; /* *lshrqi3 */
          break;

        case 1:
          if (
#line 5987 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 747; /* *lshrqq3 */
          break;

        case 2:
          if (
#line 5987 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 748; /* *lshruqq3 */
          break;

        case 3:
          if (
#line 6015 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 754; /* *lshrhi3 */
          break;

        case 4:
          if (
#line 6015 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 755; /* *lshrhq3 */
          break;

        case 5:
          if (
#line 6015 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 756; /* *lshruhq3 */
          break;

        case 6:
          if (
#line 6015 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 757; /* *lshrha3 */
          break;

        case 7:
          if (
#line 6015 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 758; /* *lshruha3 */
          break;

        case 8:
          if (
#line 6074 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 766; /* *lshrsi3 */
          break;

        case 9:
          if (
#line 6074 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 767; /* *lshrsq3 */
          break;

        case 10:
          if (
#line 6074 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 768; /* *lshrusq3 */
          break;

        case 11:
          if (
#line 6074 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 769; /* *lshrsa3 */
          break;

        case 12:
          if (
#line 6074 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 770; /* *lshrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 759; /* lshrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 6165 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 776; /* *lshrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 6165 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 777; /* *lshrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 6165 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *lshrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 6165 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 779; /* *lshrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 6165 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 780; /* *lshrusa3_const */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) == MEM)
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  operands[0] = x4;
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !nox_general_operand (operands[1], E_QImode)
          || !
#line 862 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
        return -1;
      return 116; /* movqi_insn */

    case E_QQmode:
      if (!nonimmediate_operand (operands[0], E_QQmode)
          || !nox_general_operand (operands[1], E_QQmode)
          || !
#line 862 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
        return -1;
      return 117; /* movqq_insn */

    case E_UQQmode:
      if (!nonimmediate_operand (operands[0], E_UQQmode)
          || !nox_general_operand (operands[1], E_UQQmode)
          || !
#line 862 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
        return -1;
      return 118; /* movuqq_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !nox_general_operand (operands[1], E_HImode)
          || !
#line 971 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
        return -1;
      return 133; /* *movhi */

    case E_HQmode:
      if (!nonimmediate_operand (operands[0], E_HQmode)
          || !nox_general_operand (operands[1], E_HQmode)
          || !
#line 971 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
        return -1;
      return 134; /* *movhq */

    case E_UHQmode:
      if (!nonimmediate_operand (operands[0], E_UHQmode)
          || !nox_general_operand (operands[1], E_UHQmode)
          || !
#line 971 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
        return -1;
      return 135; /* *movuhq */

    case E_HAmode:
      if (!nonimmediate_operand (operands[0], E_HAmode)
          || !nox_general_operand (operands[1], E_HAmode)
          || !
#line 971 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
        return -1;
      return 136; /* *movha */

    case E_UHAmode:
      if (!nonimmediate_operand (operands[0], E_UHAmode)
          || !nox_general_operand (operands[1], E_UHAmode)
          || !
#line 971 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
        return -1;
      return 137; /* *movuha */

    case E_PSImode:
      if (!nonimmediate_operand (operands[0], E_PSImode)
          || !nox_general_operand (operands[1], E_PSImode)
          || !
#line 1144 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
        return -1;
      return 140; /* *movpsi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nox_general_operand (operands[1], E_SImode)
          || !
#line 1204 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
        return -1;
      return 151; /* *movsi */

    case E_SQmode:
      if (!nonimmediate_operand (operands[0], E_SQmode)
          || !nox_general_operand (operands[1], E_SQmode)
          || !
#line 1204 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
        return -1;
      return 152; /* *movsq */

    case E_USQmode:
      if (!nonimmediate_operand (operands[0], E_USQmode)
          || !nox_general_operand (operands[1], E_USQmode)
          || !
#line 1204 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
        return -1;
      return 153; /* *movusq */

    case E_SAmode:
      if (!nonimmediate_operand (operands[0], E_SAmode)
          || !nox_general_operand (operands[1], E_SAmode)
          || !
#line 1204 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
        return -1;
      return 154; /* *movsa */

    case E_USAmode:
      if (!nonimmediate_operand (operands[0], E_USAmode)
          || !nox_general_operand (operands[1], E_USAmode)
          || !
#line 1204 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
        return -1;
      return 155; /* *movusa */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !nox_general_operand (operands[1], E_SFmode)
          || !
#line 1252 "../../gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
        return -1;
      return 158; /* *movsf */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      if (XWINT (x6, 0) == 1L)
        {
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) == REG
              && REGNO (x9) == 36
              && GET_MODE (x9) == E_CCmode
              && 
#line 3081 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 527; /* *ashiftqihi2.signx.1 */
        }
      x9 = XEXP (x2, 0);
      if (!scratch_operand (x9, E_QImode))
        return -1;
      operands[3] = x9;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && 
#line 3092 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 528; /* *ashifthi3.signx.const */
      operands[2] = x9;
      if (XWINT (x6, 0) != 7L
          || !
#line 3110 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 529; /* *ashifthi3.signx.const7 */

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (pattern224 (x1) != 0
          || !
#line 3128 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 530; /* *ashifthi3.zerox.const */

    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern209 (x1, 
E_QImode) != 0)
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1149; /* *extzvqi */

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1150; /* *extzvhi */

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1151; /* *extzvpsi */

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1152; /* *extzvsi */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 10454 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1156; /* *extzv.not */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (pattern242 (x1, 
UMOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UMOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 0);
      switch (REGNO (x8))
        {
        case 24:
          if (pattern379 (x1, 
E_QImode, 
E_CCmode, 
36, 
23, 
25) != 0
              || !
#line 3978 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 589; /* *udivmodqi4_call */

        case 22:
          if (pattern379 (x1, 
E_HImode, 
E_QImode, 
21, 
26, 
24) != 0)
            return -1;
          return 594; /* *udivmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern324 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3122; /* *udivsa3.call */

        case 1:
          if (!
#line 625 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3124; /* *udivusa3.call */

        default:
          return -1;
        }

    case 2:
      return 616; /* *udivmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3110; /* *udivhq3.call */

    case 4:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3112; /* *udivuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3114; /* *udivha3.call */

    case 6:
      if (!
#line 577 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3116; /* *udivuha3.call */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  x11 = XEXP (x4, 1);
  operands[1] = x11;
  x12 = XEXP (x7, 0);
  operands[0] = x12;
  x13 = XEXP (x8, 0);
  operands[4] = x13;
  x14 = XEXP (x8, 1);
  operands[5] = x14;
  x15 = XEXP (x9, 0);
  operands[2] = x15;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_CCZNmode:
      if (GET_MODE (x3) != E_CCZNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern380 (x8, 
E_HImode) != 0
              || !
#line 7334 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 916; /* *add.for.cczn.hi */

        case E_PSImode:
          if (pattern380 (x8, 
E_PSImode) != 0
              || !
#line 7334 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 917; /* *add.for.cczn.psi */

        case E_SImode:
          if (pattern380 (x8, 
E_SImode) != 0
              || !
#line 7334 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 918; /* *add.for.cczn.si */

        default:
          return -1;
        }

    case E_CCNmode:
      if (GET_MODE (x3) != E_CCNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern364 (x8, 
E_HImode) != 0
              || !
#line 7353 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 919; /* *add.for.ccn.hi */

        case E_PSImode:
          if (pattern364 (x8, 
E_PSImode) != 0
              || !
#line 7353 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 920; /* *add.for.ccn.psi */

        case E_SImode:
          if (pattern364 (x8, 
E_SImode) != 0
              || !
#line 7353 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 921; /* *add.for.ccn.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_84 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern175 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 1);
          operands[0] = x5;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          *pnum_clobbers = 2;
          return 997; /* epilogue_restores */

        case 2:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pnum_clobbers == NULL
                  || pattern279 (x1) != 0
                  || !
#line 8673 "../../gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              *pnum_clobbers = 1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern246 (x1))
                {
                case 0:
                  return 1003; /* delay_cycles_1 */

                case 1:
                  return 1005; /* delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L
              || pattern174 (x1) != 0
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern288 (x1))
            {
            case 0:
              if (!
#line 1476 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 169; /* *clrmemqi */

            case 1:
              if (!
#line 1510 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 171; /* *clrmemhi */

            default:
              return -1;
            }

        case DIV:
          if (pattern226 (x1, 
MOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern342 (x1))
            {
            case 0:
              return 584; /* divmodqi4 */

            case 1:
              return 590; /* divmodhi4 */

            case 2:
              return 612; /* divmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern343 (x1) != 0
              || !
#line 4324 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 608; /* *divmodpsi4_call */

        case UDIV:
          if (pattern226 (x1, 
UMOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern342 (x1))
            {
            case 0:
              return 587; /* udivmodqi4 */

            case 1:
              return 593; /* udivmodhi4 */

            case 2:
              return 615; /* udivmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern343 (x1) != 0
              || !
#line 4373 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 611; /* *udivmodpsi4_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (pattern149 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_HImode)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE
              || pattern369 (x1, 
E_CCmode, 
36) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[0] = x12;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x13 = XEXP (x10, 1);
          x14 = XEXP (x13, 1);
          operands[1] = x14;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          return 996; /* call_prologue_saves */

        case 2:
          if (XINT (x4, 1) != 10)
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 6
              || GET_MODE (x16) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER
              || pattern247 (x1) != 0)
            return -1;
          switch (XWINT (x15, 0))
            {
            case 3L:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 36
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 8837 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1008; /* *delay_cycles_3 */

            case 4L:
              x6 = XEXP (x3, 0);
              operands[5] = x6;
              if (!scratch_operand (operands[5], E_QImode))
                return -1;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_135 (insn, operands);

        case 1:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 3:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 5:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_145 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_138 (insn, operands);

        case 2:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_140 (insn, operands);

        case 4:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 5:
          if (!(
#line 2015 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2017 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern192 (x2, 
E_PSImode) != 0
              || !
#line 2077 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_QImode:
          if (pattern213 (x2, 
E_QImode) != 0
              || !
#line 2104 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_QQmode:
          if (pattern213 (x2, 
E_QQmode) != 0
              || !
#line 2104 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_UQQmode:
          if (pattern213 (x2, 
E_UQQmode) != 0
              || !
#line 2104 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 2:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_170 (insn, operands);

        case 3:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 5:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 6:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 8:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        case 1:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_169 (insn, operands);

        case 2:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        case 3:
          if (!
#line 2299 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 5:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 6:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 7:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 8:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 9:
          if (!(
#line 2350 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 2352 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_205 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      switch (pattern133 (x2))
        {
        case 0:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_238 (insn, operands);

        case 1:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_246 (insn, operands);

        case 2:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_254 (insn, operands);

        case 3:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_262 (insn, operands);

        case 4:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 5:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        case 6:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_256 (insn, operands);

        case 7:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_264 (insn, operands);

        case 8:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_242 (insn, operands);

        case 9:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_250 (insn, operands);

        case 10:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_258 (insn, operands);

        case 11:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_266 (insn, operands);

        case 12:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_244 (insn, operands);

        case 13:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_252 (insn, operands);

        case 14:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_260 (insn, operands);

        case 15:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_268 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      switch (pattern133 (x2))
        {
        case 0:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 1:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_247 (insn, operands);

        case 2:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_263 (insn, operands);

        case 4:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_241 (insn, operands);

        case 5:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        case 6:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_257 (insn, operands);

        case 7:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_265 (insn, operands);

        case 8:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_243 (insn, operands);

        case 9:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_251 (insn, operands);

        case 10:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_259 (insn, operands);

        case 11:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_267 (insn, operands);

        case 12:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_245 (insn, operands);

        case 13:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_253 (insn, operands);

        case 14:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_261 (insn, operands);

        case 15:
          if (!
#line 2422 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern190 (x2) != 0
              || !register_operand (operands[2], E_QImode)
              || !(
#line 2618 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2620 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_278 (insn, operands);

        case SIGN_EXTEND:
          if (pattern211 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2730 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2732 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_283 (insn, operands);

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2794 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2798 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern211 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2730 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2732 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_284 (insn, operands);

            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2794 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2798 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_287 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern192 (x2, 
E_QImode) == 0
              && (
#line 2205 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2207 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_162 (insn, operands);
          break;

        case E_HImode:
          if (pattern192 (x2, 
E_HImode) == 0
              && (
#line 3273 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3275 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_310 (insn, operands);
          break;

        case E_QQmode:
          if (pattern192 (x2, 
E_QQmode) == 0
              && (
#line 296 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 298 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1821 (insn, operands);
          break;

        case E_UQQmode:
          if (pattern192 (x2, 
E_UQQmode) == 0
              && (
#line 317 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 319 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1822 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 16
          || GET_CODE (x5) != REG
          || REGNO (x5) != 20
          || GET_CODE (x4) != REG)
        return NULL;
      switch (pattern25 (x1, 
24))
        {
        case 0:
          if (!(
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1828 (insn, operands);

        case 1:
          if (!(
#line 468 "../../gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1829 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (register_operand (operands[1], E_QImode))
            {
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x6) != REG)
            return NULL;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          switch (REGNO (x6))
            {
            case 18:
              if (GET_MODE (x6) != E_HImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != SIGN_EXTEND
                  || pattern249 (x5, 
E_HImode, 
E_SImode) != 0
                  || pattern198 (x1, 
E_SImode, 
22) != 0
                  || !(
#line 3775 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3777 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_337 (insn, operands);

            case 26:
              if (pattern199 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0
                  || !(
#line 3846 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3848 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case 25:
              if (pattern199 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
                  || !(
#line 4225 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4227 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_357 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_975 (insn, operands);

        case 2:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_977 (insn, operands);

        case 3:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_981 (insn, operands);

        case 4:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_979 (insn, operands);

        case 5:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_983 (insn, operands);

        case 6:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_985 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return NULL;
          switch (pattern134 (x1))
            {
            case 0:
              if (!(
#line 3775 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3777 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            case 1:
              if (!(
#line 3825 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3827 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case 2:
              if (!(
#line 3846 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3848 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_976 (insn, operands);

        case 2:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_978 (insn, operands);

        case 3:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_982 (insn, operands);

        case 4:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_980 (insn, operands);

        case 5:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_984 (insn, operands);

        case 6:
          if (!(
#line 10870 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10874 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_986 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != NOT)
        return NULL;
      if (GET_MODE (x7) == E_QImode)
        {
          res = split_5 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_MODE (x7) != E_HImode
          || pattern163 (x1) != 0
          || !(
#line 3867 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3869 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_344 (insn, operands);

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_955 (insn, operands);

        case 1:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_959 (insn, operands);

        case 2:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_963 (insn, operands);

        case 3:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_967 (insn, operands);

        case 4:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_956 (insn, operands);

        case 5:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_960 (insn, operands);

        case 6:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_964 (insn, operands);

        case 7:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_968 (insn, operands);

        case 8:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_957 (insn, operands);

        case 9:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_961 (insn, operands);

        case 10:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_965 (insn, operands);

        case 11:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_969 (insn, operands);

        case 12:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_958 (insn, operands);

        case 13:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_962 (insn, operands);

        case 14:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_966 (insn, operands);

        case 15:
          if (!(
#line 10840 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_970 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern88 (x1))
        {
        case 0:
          if (
#line 6223 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_540 (insn, operands);
          break;

        case 1:
          if (
#line 6259 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_542 (insn, operands);
          break;

        case 2:
          if (
#line 6279 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_543 (insn, operands);
          break;

        case 3:
          if (
#line 6300 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_544 (insn, operands);
          break;

        case 4:
          if (
#line 6334 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_545 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern89 (x1))
            {
            case 0:
              if (!(
#line 10547 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_747 (insn, operands);

            case 1:
              if (!(
#line 10547 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_748 (insn, operands);

            case 2:
              if (!(
#line 10547 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_749 (insn, operands);

            case 3:
              if (!(
#line 10547 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_750 (insn, operands);

            default:
              return NULL;
            }

        case REG:
          if (REGNO (x3) != 18
              || GET_MODE (x3) != E_DImode
              || pattern34 (x1, 
E_DImode, 
18) != 0
              || !(
#line 421 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 423 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1919 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!
#line 6241 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_541 (insn, operands);

    case 2:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_790 (insn, operands);

    case 3:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_791 (insn, operands);

    case 4:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_792 (insn, operands);

    case 5:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_793 (insn, operands);

    case 6:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_794 (insn, operands);

    case 7:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_795 (insn, operands);

    case 8:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_796 (insn, operands);

    case 9:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_797 (insn, operands);

    case 10:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_802 (insn, operands);

    case 11:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_803 (insn, operands);

    case 12:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_804 (insn, operands);

    case 13:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_805 (insn, operands);

    case 14:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_798 (insn, operands);

    case 15:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_799 (insn, operands);

    case 16:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_800 (insn, operands);

    case 17:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_801 (insn, operands);

    case 18:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_806 (insn, operands);

    case 19:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_807 (insn, operands);

    case 20:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_808 (insn, operands);

    case 21:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_809 (insn, operands);

    case 22:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_810 (insn, operands);

    case 23:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_811 (insn, operands);

    case 24:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_812 (insn, operands);

    case 25:
      if (!(
#line 10675 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_813 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (pattern49 (x1) != 0
          || !
#line 5743 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_502 (insn, operands);

    case REG:
    case SUBREG:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 6572 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_556 (insn, operands);

        case 1:
          if (!
#line 6588 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_557 (insn, operands);

        case 2:
          if (!
#line 6619 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_559 (insn, operands);

        case 3:
          if (!
#line 6603 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_558 (insn, operands);

        case 4:
          if (!
#line 6653 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_561 (insn, operands);

        case 5:
          if (!
#line 6669 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_562 (insn, operands);

        case 6:
          if (!
#line 6682 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_563 (insn, operands);

        case 7:
          if (!
#line 6698 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_564 (insn, operands);

        case 8:
          if (!
#line 6714 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_565 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_QImode
          || pattern35 (x1, 
E_QImode, 
24) != 0
          || !
#line 9216 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_639 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_QImode
          || pattern34 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode)
          && (
#line 9277 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 9279 "../../gcc/config/avr/avr.md"
( 1)))
        return gen_split_641 (insn, operands);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_QImode)
        return NULL;
      return gen_split_645 (insn, operands);

    case ZERO_EXTRACT:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 10608 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10610 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_764 (insn, operands);

        case 1:
          if (!(
#line 10608 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10610 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_765 (insn, operands);

        case 2:
          if (!(
#line 10608 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10610 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_766 (insn, operands);

        case 3:
          if (!(
#line 10608 "../../gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10610 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_767 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_24 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (REGNO (x5))
    {
    case 30:
      switch (pattern250 (x5))
        {
        case 0:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 1:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_18 (insn, operands);

        case 2:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 3:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_20 (insn, operands);

        case 4:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_21 (insn, operands);

        case 5:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_22 (insn, operands);

        case 6:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_23 (insn, operands);

        case 7:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_24 (insn, operands);

        case 8:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_25 (insn, operands);

        case 9:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_26 (insn, operands);

        case 10:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_27 (insn, operands);

        case 11:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_28 (insn, operands);

        case 12:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_29 (insn, operands);

        case 13:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_30 (insn, operands);

        case 14:
          if (!(
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))) && 
#line 604 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_31 (insn, operands);

        default:
          return NULL;
        }

    case 36:
      if (GET_MODE (x5) != E_CCmode)
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_QImode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_70 (insn, operands);

        case E_QQmode:
          if (!nonimmediate_operand (operands[0], E_QQmode)
              || !general_operand (operands[1], E_QQmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_71 (insn, operands);

        case E_UQQmode:
          if (!nonimmediate_operand (operands[0], E_UQQmode)
              || !general_operand (operands[1], E_UQQmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_72 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !general_operand (operands[1], E_HImode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_73 (insn, operands);

        case E_HQmode:
          if (!nonimmediate_operand (operands[0], E_HQmode)
              || !general_operand (operands[1], E_HQmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_74 (insn, operands);

        case E_UHQmode:
          if (!nonimmediate_operand (operands[0], E_UHQmode)
              || !general_operand (operands[1], E_UHQmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_75 (insn, operands);

        case E_HAmode:
          if (!nonimmediate_operand (operands[0], E_HAmode)
              || !general_operand (operands[1], E_HAmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_76 (insn, operands);

        case E_UHAmode:
          if (!nonimmediate_operand (operands[0], E_UHAmode)
              || !general_operand (operands[1], E_UHAmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_77 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_78 (insn, operands);

        case E_SQmode:
          if (!nonimmediate_operand (operands[0], E_SQmode)
              || !general_operand (operands[1], E_SQmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_79 (insn, operands);

        case E_USQmode:
          if (!nonimmediate_operand (operands[0], E_USQmode)
              || !general_operand (operands[1], E_USQmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_80 (insn, operands);

        case E_SAmode:
          if (!nonimmediate_operand (operands[0], E_SAmode)
              || !general_operand (operands[1], E_SAmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_81 (insn, operands);

        case E_USAmode:
          if (!nonimmediate_operand (operands[0], E_USAmode)
              || !general_operand (operands[1], E_USAmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_82 (insn, operands);

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || !general_operand (operands[1], E_SFmode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_83 (insn, operands);

        case E_PSImode:
          if (!nonimmediate_operand (operands[0], E_PSImode)
              || !general_operand (operands[1], E_PSImode)
              || !
#line 1073 "../../gcc/config/avr/avr.md"
(reload_completed
   && (MEM_P (operands[0]) || MEM_P (operands[1]))))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (pattern319 (x4) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern381 (x5) != 0)
    return NULL;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_PSImode)
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (pattern388 (x9, 
E_PSImode))
        {
        case 0:
          if (!
#line 7410 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_200 (insn, operands);

        case 1:
          if (!
#line 7410 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_201 (insn, operands);

        case 2:
          if (!
#line 7410 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_202 (insn, operands);

        case 3:
          if (!
#line 7410 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_203 (insn, operands);

        case 4:
          if (!
#line 7410 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_204 (insn, operands);

        case 5:
          if (!
#line 7410 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_205 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern390 (x3))
        {
        case 0:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_206 (insn, operands);

        case 1:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_207 (insn, operands);

        case 2:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_208 (insn, operands);

        case 3:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_209 (insn, operands);

        case 4:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_210 (insn, operands);

        case 5:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_211 (insn, operands);

        case 6:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_218 (insn, operands);

        case 7:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_219 (insn, operands);

        case 8:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_220 (insn, operands);

        case 9:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_221 (insn, operands);

        case 10:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_222 (insn, operands);

        case 11:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_223 (insn, operands);

        case 12:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_242 (insn, operands);

        case 13:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_243 (insn, operands);

        case 14:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_244 (insn, operands);

        case 15:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_245 (insn, operands);

        case 16:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_246 (insn, operands);

        case 17:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_247 (insn, operands);

        case 18:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_230 (insn, operands);

        case 19:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_231 (insn, operands);

        case 20:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_232 (insn, operands);

        case 21:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_233 (insn, operands);

        case 22:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_234 (insn, operands);

        case 23:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_235 (insn, operands);

        case 24:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_254 (insn, operands);

        case 25:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_255 (insn, operands);

        case 26:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_256 (insn, operands);

        case 27:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_257 (insn, operands);

        case 28:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_258 (insn, operands);

        case 29:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_259 (insn, operands);

        case 30:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_266 (insn, operands);

        case 31:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_267 (insn, operands);

        case 32:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_268 (insn, operands);

        case 33:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_269 (insn, operands);

        case 34:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_270 (insn, operands);

        case 35:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_271 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern390 (x3))
        {
        case 0:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_212 (insn, operands);

        case 1:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_213 (insn, operands);

        case 2:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_214 (insn, operands);

        case 3:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_215 (insn, operands);

        case 4:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_216 (insn, operands);

        case 5:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(2 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_217 (insn, operands);

        case 6:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_224 (insn, operands);

        case 7:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_225 (insn, operands);

        case 8:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_226 (insn, operands);

        case 9:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_227 (insn, operands);

        case 10:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_228 (insn, operands);

        case 11:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_229 (insn, operands);

        case 12:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_248 (insn, operands);

        case 13:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_249 (insn, operands);

        case 14:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_250 (insn, operands);

        case 15:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_251 (insn, operands);

        case 16:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_252 (insn, operands);

        case 17:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(3 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_253 (insn, operands);

        case 18:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_236 (insn, operands);

        case 19:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_237 (insn, operands);

        case 20:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_238 (insn, operands);

        case 21:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_239 (insn, operands);

        case 22:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_240 (insn, operands);

        case 23:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 1
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_241 (insn, operands);

        case 24:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_260 (insn, operands);

        case 25:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_261 (insn, operands);

        case 26:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_262 (insn, operands);

        case 27:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_263 (insn, operands);

        case 28:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_264 (insn, operands);

        case 29:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 2
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_265 (insn, operands);

        case 30:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_272 (insn, operands);

        case 31:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_273 (insn, operands);

        case 32:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_274 (insn, operands);

        case 33:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_275 (insn, operands);

        case 34:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_276 (insn, operands);

        case 35:
          if (!
#line 7441 "../../gcc/config/avr/avr.md"
(4 > 3
   && peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_277 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
